%consider an image deburring problem with a known blurring kernal
%L2 data fidelity term + l_1 norm frame cofficients as regularization
function [u Res timerun epssu]= L2data_framef(bvec2,bvec3, H, ind, lambda, mu, tol, maxit, maxcgit,N,dataTruth,bvec4,ND,NPROJ,lambda2,lambda3, mu2, maxcgit2,w,q,uu)
%INPUT:
    %Bn -- Blurred noisy image
    %H -- blurring kernal
    %ind -- index of pixels used for fitting
    %lambda -- regularization parameter
    %mu -- parameter for split Bregman iteration
    %tol -- parameter for split Bregman iteration
    %maxit -- maximum iteration
    %maxcgit -- maximun number of CG iterations

%OUTPUT:
    %u -- deblurred image

    
%========================
%   framelet transform
%========================
tic
order = 1; dlevel = 1; 
order2 = 3;dlevel2 = 3;
lowpass = kron([1/4 1/2 1/4]',[1/4 1/2 1/4]);
W = @(z) swt2(z, order, dlevel);
WT = @(z) iswt2(z, order, dlevel);
W2 = @(z) swt2(z, order2, dlevel2);
WT2 = @(z) iswt2(z, order2, dlevel2);

% W2 = @(z) dct(z);
% WT2 = @(z) idct(z);


%==============================
%   split Bregman iteration
%==============================
%initialization

u = uu;
Res=[epss(dataTruth,u)];
% w = W(u); q = w; %3D matrix to store frame coefficients
u2 = zeros(ND,NPROJ*2+8);
w2 = W2(u2); q2 = w2; %3D matrix to store frame coefficients
%iteration 
error = 10*tol;
epssu=[];
it = 1; 
ind2=zeros(ND,NPROJ*2+8);
ind2(:,6:2:NPROJ*2+4) = ones(ND,NPROJ);
      tolu=0.001;

      erru=100;
 
      timerun=[toc];
while (erru > tolu &&it <maxit )
    tic
    disp(epss(dataTruth,u))
    if(it==1)
        pp=1;
    else
        pp=1;
    end;  
    fk=bvec3;
    for j=1:pp
        indd=zeros(ND,NPROJ*2+8);
        indd(:,5:2*NPROJ+4)=1;
        rhs=double(zeros(ND,NPROJ*2+8));
        rhs(:,5:2:NPROJ*2+3) = bvec3(:,1:2:end);
        %rhs = imfilter(tmp, H, 'symmetric','conv');
        rhs(:,6:2:NPROJ*2+4) = lambda3*bvec2;
        w2(:,:,1)=0; 
        q2(:,:,1)=0;
        rhs = rhs+mu2*WT2(w2-q2);
        rhs = rhs.*indd;
%         u2(:,2:2:end) = rhs(:,2:2:end)/(1+mu2+lambda3);  % direct method  for (1.2)
%         u2(:,1:2:end) = rhs(:,1:2:end)/(1+mu2);

       
      u2 = FrameL2_CG2(1, ind2, mu2, lambda3,lowpass, rhs, maxcgit2,indd); %CG for (1.2)

        %soft-thresholding
        Wu2 = W2(u2);
        w2 = softthresh(Wu2+q2, lambda2/mu2,dlevel2);

        %update residual
        ev1 = (Wu2-w2);
        q2 = q2+ev1;
        u2((u2<0.0))=0.0;
        bvec3 = u2(:,5:2*NPROJ+4);
%  display(epss(bvec2,bvec3(:,2:2:end)));
%         bvec3(:,2:2:end) = bvec2;
%         if(mod(it,2)==0)
%             figure;
%             imshow(u2,[]);
%         end;
%         display(epss(bvec2,bvec3(:,2:2:NPROJ*2)));
    end;
    
    uk=u;
%     bvec3 = L2data_frameolda(bvec2,bvec3, 1, ind2, lambda2, mu2,lambda3, tol2, 1, maxcigt2);
    %display(epss(bvec4,bvec3));
    bvec=reshape(bvec3,ND*NPROJ*2,1);
    Bn=bvec;

    if(pp>1)
        pp=3;
    else
        pp=1;
    end;
    %solve a linear system by the conjugate gradient method
    %an efficient alternative: diagonalize the matrix by DCT 
    for j = 1:pp
        tmp = ind.*Bn;
        tmp=reshape(tmp,ND,NPROJ*2);
        tmp(:,2:2:end)=bvec2*lambda3;
        tmp=reshape(tmp,ND*NPROJ*2,1);
        %rhs = imfilter(tmp, H, 'symmetric','conv');
        rhs = H'*tmp;
        rhs=reshape(rhs,N,N);
    %     rhs = conj_imfilter(tmp, H);
        w(:,:,1)=0; 
        q(:,:,1)=0;
        rhs = rhs+mu*WT(w-q);
        u = FrameL2_CG(H, ind, mu,lambda3, lowpass, rhs, maxcgit,N,ND,NPROJ);

        %soft-thresholding
        Wu = W(u);
        w = softthresh(Wu+q, lambda/mu,dlevel);

        %update residual
        ev1 = (Wu-w);
        q = q+ev1;

        %error
        ev1(:,:,1)=0;
        if(j==pp)
            it = it+1;
        end;
        error = sqrt(sum(ev1(:).^2));
        u(find(u<0.0))=0.0;
       % fprintf('at iteration %d, residual norm is %f\n', it, error);
     %   display(epss(dataTruth,u));
    end;
    bvec3 = H*reshape(u,N*N,1);
    bvec3 = reshape(bvec3,ND,NPROJ*2);
    erru=epss(u,uk);
    epssu=[epssu erru];
    fprintf(1,'erru=%f\n',erru)
      %display(epss(dataTruth,u));
      Res=[Res,epss(dataTruth,u)];
  %  display(corr(dataTruth,u));
       % imshow(u,[]);
      %  drawnow;
      trun=toc+timerun(end);
      timerun=[timerun trun];
end;


% u(posi==0)=0.0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  the followings are auxiliary functions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%conjugate gradient to the linear system (H'*H+mu(I-A'*A))x = rhs
%because A'A+D1'*D1+....+Dr'*Dr=I
function x = FrameL2_CG2(H, ind, mu,lambda2, lowpass, rhs, maxcgit,indd)

x = zeros(size(rhs));
r = rhs;
d = rhs;
rtr = r(:)'*r(:);
niters = 0;
while (rtr > 1e-10 && niters < maxcgit)
    niters = niters+1;
    %compute Ad
    tmp=indd.*d;
    tmp = imfilter(tmp,H, 'symmetric', 'conv');
%     tmp = ind.*tmp;
    %tmp = imfilter(tmp, H, 'symmetric', 'conv');
    tmp = conj_imfilter(tmp, H);
    tmp = (lambda2-1)*ind.*d+tmp;
    Ad = tmp+mu*d;
    tmp = imfilter(d, lowpass, 'symmetric', 'conv');
    tmp = imfilter(tmp, lowpass, 'symmetric', 'conv');
    Ad = Ad-mu*tmp;
    %compute Ad
    alpha = rtr/(d(:)'*Ad(:));
    x = x + alpha*d;
    r = r - alpha*Ad;
    rtrold = rtr;
    rtr = r(:)'*r(:);
    beta = rtr/rtrold;
    d = r + beta*d;
end



function x = FrameL2_CG(H, ind, mu,lambda, lowpass, rhs, maxcgit,N,ND,NPROJ)

x = zeros(size(rhs));
r = rhs;
d = rhs;
rtr = r(:)'*r(:);
niters = 0;
while (rtr > 1e-10 && niters < maxcgit)
    niters = niters+1;
    %compute Ad
    tmp=H*reshape(d,N*N,1);
%     tmp = imfilter(d, H, 'symmetric', 'conv');
    tmp = ind.*tmp;
    tmp=reshape(tmp,ND,NPROJ*2);
    tmp(:,2:2:end)=tmp(:,2:2:end)*lambda;
    tmp=reshape(tmp,ND*NPROJ*2,1);
%     tmp = imfilter(tmp, H, 'symmetric', 'conv');
%     tmp = conj_imfilter(tmp, H);
    tmp=reshape(H'*tmp,N,N);
    Ad = tmp+mu*d;
    tmp = imfilter(d, lowpass, 'symmetric', 'conv');
    tmp = imfilter(tmp, lowpass, 'symmetric', 'conv');
    Ad = Ad-mu*tmp;
    %compute Ad
    alpha = rtr/(d(:)'*Ad(:));
    x = x + alpha*d;
    r = r - alpha*Ad;
    rtrold = rtr;
    rtr = r(:)'*r(:);
    beta = rtr/rtrold;
    d = r + beta*d;
end



%soft-thresholding
function ds1 = softthresh(ds,t,level)
ds1=ds;
[a b c] = size(ds);
d=(c-1)/level;
dn=double(zeros(a,b));
tp=zeros(1,c);
for l = 1:level
    for i = 1:a
        for j = 1:b
            tp(:)=ds(i,j,:);
            dn(i,j) = norm(tp(2+(l-1)*d:d*l+1),2);
        end;
    end;
    res = (abs(dn) - t*sqrt(d)*2/(2^l));
    res = (res + abs(res))/2;
    for k = 2+(l-1)*d:d*l+1
      ds1(:,:,k) = ds(:,:,k).*res./(dn+1e-20);
    end;
end;

function ds1 = softthresh2(ds,t,level,posi)
ds1=ds;
[a b c] = size(ds);
d=(c-1)/level;
dn=double(zeros(a,b));
tp=zeros(1,c);
for l = 1:level
    for i = 1:a
        for j = 1:b
            tp(:)=ds(i,j,:);
            dn(i,j) = norm(tp(2+(l-1)*d:d*l+1),2);
        end;
    end;
    res = (abs(dn) - t*sqrt(d)*2/(2^l));
    res = (res + abs(res))/2;
    for k = 2+(l-1)*d:d*l+1
      ds1(:,:,k) = ds(:,:,k).*res./(dn+1e-20);
    end;
end;
% ds1(posi==0)=ds(posi==0);

%compute D1'*u(D2'*u) by imfilter, where D1 and D2 correspond to 
%non-symmetric filter with symmetric boundary condition
function ru = conj_imfilter(u, H)

ru = imfilter(u, rot90(H,2), 'conv');

% function ru = conj_imfilter(u, fil)
% 
% sym_part = imfilter(u, fil, 'symmetric', 'conv')-imfilter(u,fil, 0, 'conv');
% nonsys_part = imfilter(u, flipud(fliplr(fil)), 0, 'conv');
% ru = sym_part+nonsym_part;
%=======================================================